Bug 60905 - kernel upgrade failed - lilo test?
kernel upgrade failed - lilo test?
Status: CLOSED DUPLICATE of bug 61512
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: up2date (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Adrian Likins
Jay Turner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-03-08 15:45 EST by Isaiah Weiner
Modified: 2015-01-07 18:55 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2002-03-08 17:51:22 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Isaiah Weiner 2002-03-08 15:45:25 EST
Description of problem:
Using RHN to schedule a kernel update to a machine that does not prohibit 
kernel* package upgrades, the process failed with a not-very-helpful error 
message.  Have you seen this before?  I wasn't sure if the problem was in 
up2date or in the kernel RPM.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. schedule kernel update
2. rhn_check -v

Actual Results:  % sudo rhn_check -v
handle_action actionid = 1932476, version = 2
The following packages were added to your selection to satisfy
dependencies:

Name                                    Version        Release
--------------------------------------------------------------
mkinitrd                                3.2.6         
1                   

kernel-2.4.9-31.i686.rpm:    Retrieved.
kernel-doc-2.4.9-31.i386.rp  Retrieved.
kernel-headers-2.4.9-31.i38  Retrieved.
kernel-source-2.4.9-31.i386  Retrieved.
mkinitrd-3.2.6-1.i386.rpm:   Retrieved.
Preparing...                 
Installing /var/spool/up2date/kernel-doc-2.4.9-31.i386.rpm...

Installing /var/spool/up2date/kernel-headers-2.4.9-31.i386.rpm...

Installing /var/spool/up2date/kernel-source-2.4.9-31.i386.rpm...
error: cannot remove /usr/src/linux-2.4.2/scripts - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/wanrouter - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/unix - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/tux - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/sunrpc - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/sched - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/packet - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/netlink - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/irda/irnet - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/irda/irlan - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/irda/ircomm - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/net/irda - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/ipx - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/ipv6/netfilter - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/net/ipv6 - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/ipv4/netfilter - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/net/ipv4/ipvs - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/ipv4 - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/ethernet - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/decnet - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/core - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/bridge - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/atm - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net/appletalk - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/net/802 - directory not empty
error: cannot remove /usr/src/linux-2.4.2/net - directory not empty
error: cannot remove /usr/src/linux-2.4.2/mm - directory not empty
error: cannot remove /usr/src/linux-2.4.2/lib - directory not empty
error: cannot remove /usr/src/linux-2.4.2/kernel - directory not empty
error: cannot remove /usr/src/linux-2.4.2/ipc - directory not empty
error: cannot remove /usr/src/linux-2.4.2/init - directory not empty
error: cannot remove /usr/src/linux-2.4.2/include/linux - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/vfat - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/umsdos - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/ufs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/udf - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/sysv - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/smbfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/romfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/reiserfs - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/ramfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/proc - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/partitions - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/nls - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/nfsd - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/nfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/ncpfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/msdos - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/minix - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/lockd - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/isofs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/hpfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/hfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/fat - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/ext2 - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/devpts - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/cramfs/inflate - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/fs/cramfs - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/coda - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/bfs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/fs/autofs4 - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs/autofs - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/fs - directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/video/riva - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/video/matrox -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/video - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/usb/storage -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/usb/serial - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/usb - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/telephony - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/sound/emu10k1 -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/sound/cs4281 -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/sound - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/sensors - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/scsi/pcmcia -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/scsi/aic7xxx_new -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/scsi/aacraid -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/scsi - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/pnp - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/pcmcia - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/pci - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/parport - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/wan - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/tulip - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/tokenring -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/skfp - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/sk98lin -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/pcmcia - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/irda - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/fc - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/cipe - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/bcm - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net/appletalk -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/net - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/misc - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/message/i2o -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/message/fusion -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/message - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/media/video -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/media/radio -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/media - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/md - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn/pcbit - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn/isdnloop -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn/icn - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn/hysdn - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn/hisax - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn/avmb1 - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/isdn - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/input - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/ieee1394 - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/ide - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/i2c - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/pcmcia -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/joystick -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/ftape/zftape -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/ftape/lowlevel -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/ftape/compressor
- directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/ftape - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/drm - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char/agp - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/char - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/cdrom - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/block/paride -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/drivers/block - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers/atm - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/drivers - directory not empty
error: cannot remove /usr/src/linux-2.4.2/arch/i386/mm - directory not
empty
error: removal of /usr/src/linux-2.4.2/arch/i386/math-emu/.depend
failed: No such file or directory
error: cannot remove /usr/src/linux-2.4.2/arch/i386/lib - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/arch/i386/kernel - directory
not empty
error: cannot remove /usr/src/linux-2.4.2/arch/i386/boot/tools -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/arch/i386/boot/compressed -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/arch/i386/boot - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/arch/i386 - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/modules -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/sb
- directory not empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/pci - directory not
empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/isa - directory not
empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/i2c - directory not
empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/gus - directory not
empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/generic - directory not
empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel/emu10k1 - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/lowlevel -
directory not empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/kernel/seq/oss - directory not
empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/kernel/seq/instr - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/kernel/seq
- directory not empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/kernel/plugin - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/kernel -
directory not empty
error: cannot remove
/usr/src/linux-2.4.2/alsa-driver-0.5.11/include/modules - directory not
empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/include -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11/cards -
directory not empty
error: cannot remove /usr/src/linux-2.4.2/alsa-driver-0.5.11 - directory
not empty
error: cannot remove /usr/src/linux-2.4.2 - directory not empty

Installing /var/spool/up2date/mkinitrd-3.2.6-1.i386.rpm...

Installing /var/spool/up2date/kernel-2.4.9-31.i686.rpm...
Error installing lilo.conf  The message was:
test install of lilo failed
Sending back response: (18, 'Failed: packages requested raised 
dependency problems', {})


Additional info:

lilo.conf:
boot=/dev/hda
map=/boot/map
install=/boot/boot.b
prompt
timeout=50
message=/boot/message
linear
default=linux
vga="788"

image=/boot/vmlinuz-2.4.2-7
        label=linux
        read-only
        root=/dev/hda5

other=/dev/hda2
        optional
        label=W2K
Comment 1 Isaiah Weiner 2002-03-08 15:46:45 EST
Is there a copy of the lilo.conf it tried to use lying around anywhere?
Comment 2 Isaiah Weiner 2002-03-08 16:26:48 EST
The problem lies in a customized message graphic.  The filename was changed, 
and a symlink made.  The actual LILO error message is very helpful, is there 
any chance of making the up2date error message more helpful?
Comment 3 Adrian Likins 2002-03-08 16:45:57 EST
I'll take a look to see if the error can be more helpful.

A failure is a failure though, and I'd rather avoid getting 
up2date in the game of diaganosing bad lilo config files. 

The action error messaging for dep cases like you described
for packages on the skip lists should be greatly improved
in newish versions of the client (2.7.40 or so...)

whats up with the kernel-source rpm? why's it complaining
it so much?

In cases where the lilo test fails, I write the original
lilo.conf back into place as /etc/lilo.conf. The "new" lilo's
are deleted however, so there isnt one lying around. 

I assume the current lilo works correctly?
Comment 4 Isaiah Weiner 2002-03-08 16:54:29 EST
Is there any way you can use the failure message lilo (or any other program) 
gives you as the failure message?

The machine is an IBM T20 ThinkPad, so it needs special ALSA modules, which the 
owner forgot to remove.

The existing lilo does correctly work.
Comment 5 Isaiah Weiner 2002-03-08 16:59:11 EST
The client version is 2.7.11-7.x.1, by the way.
Comment 6 Adrian Likins 2002-03-08 17:11:10 EST
>Is there any way you can use the failure message lilo (or any other program) 
>gives you as the failure message?
  Possibly, I'll look into it. 

Comment 7 Adrian Likins 2002-03-08 17:12:31 EST
You mention an error related to a boot messages file. What was the
error message (and how did you discover that?)

The generated lilo.conf's looks okay to me so far, but I'll
keep playing.
Comment 8 Isaiah Weiner 2002-03-08 17:22:10 EST
Put an entry in lilo.conf that has the message file be something that is a 
symlink to something that doesn't exist.  So perhaps it points 
to /boot/message, but /boot/message is a symlink to /boot/message-custom, 
and /boot/message-custom doesn't exist.  When you run lilo you should get the 
fatal 'file doesn't exist' error.
Comment 9 Isaiah Weiner 2002-03-08 17:22:48 EST
I discovered it by completing the kernel upgrade manually so I could upgrade X.
Comment 10 Adrian Likins 2002-03-08 17:33:46 EST
ah.

when up2date was ran the first time, the existing lilo.conf pointed to
a dead symlink? If the existing lilo.conf is broken, the chances that
the one up2date replaces it with are extremely high. It's assume that 
the installed lilo is working, so thats where the failure comes from
at least.

I think I'll see if I can start `lilo -t` the existing lilo.conf before
I do anything, might save some debug time.
Comment 11 Isaiah Weiner 2002-03-08 17:39:58 EST
Correct - between the last successful lilo running and the package upgrade 
attempt the file went away.

Cool, thanks for looking at it.
Comment 12 Isaiah Weiner 2002-03-08 17:40:49 EST
Might it be possible to continue with the kernel upgrade anyway, and notify the 
user that LILO didn't successfully run?
Comment 13 Adrian Likins 2002-03-08 17:51:18 EST
The bootloader munging doesnt happen until after the transaction set
has ran (I can't run a lilo -t until the kernels are in place and on
the file system).

The depenency error is an artifact of an woefully inadequate 
action error reporting scheme. This should actually be improved
significantly in current clients ( 2.7.42 for example). Basically,
if anything fails that isnt one of the couple of exceptions the
action knows about, it says it's a dep error. Lame, and hopefully
better versions of this will hit the street soon.

Of course, that raises the question of is a kernel install without
a bootloader install a sucess or a failure. The answers seems to be "sorta".
I seem to have several of those cases. Attempting to come up with a sane
way to communicate a "sorta" failure now.
Comment 14 Adrian Likins 2002-05-15 15:56:02 EDT

*** This bug has been marked as a duplicate of 61512 ***

Note You need to log in before you can comment on or make changes to this bug.